博客
关于我
强烈建议你试试无所不能的chatGPT,快点击我
poj 3628 Bookshelf 2
阅读量:4648 次
发布时间:2019-06-09

本文共 2057 字,大约阅读时间需要 6 分钟。

                                                                                                                                     
Time Limit: 1000MS   Memory Limit: 65536K
Total Submissions: 10981   Accepted: 4860

Description

Farmer John recently bought another bookshelf for the cow library, but the shelf is getting filled up quite quickly, and now the only available space is at the top.

FJ has N cows (1 ≤ N ≤ 20) each with some height of Hi (1 ≤ Hi ≤ 1,000,000 - these are very tall cows). The bookshelf has a height of B (1 ≤ B ≤ S, where S is the sum of the heights of all cows).

To reach the top of the bookshelf, one or more of the cows can stand on top of each other in a stack, so that their total height is the sum of each of their individual heights. This total height must be no less than the height of the bookshelf in order for the cows to reach the top.

Since a taller stack of cows than necessary can be dangerous, your job is to find the set of cows that produces a stack of the smallest height possible such that the stack can reach the bookshelf. Your program should print the minimal 'excess' height between the optimal stack of cows and the bookshelf.

Input

* Line 1: Two space-separated integers: N and B

* Lines 2..N+1: Line i+1 contains a single integer: Hi

Output

* Line 1: A single integer representing the (non-negative) difference between the total height of the optimal set of cows and the height of the shelf.

Sample Input

5 1631356

Sample Output

1

Source

思路:如果正向去计算大于d的最小值,贪心是很好实现的,但是DP想起来有点困难,所以就换了个思路。设sum为所有奶牛的高度和,则sum>=B,那么我们就可以设有一个容量为sum-B的背包,要让里面所有牛的高度尽量大,那余下的就是我们要求的值了,这就转换成简单的01背包了。
吐槽:不知道从哪位dalao博客里仿佛见到过“正难则反”(xxy是我o(*^▽^*)┛是我✿✿ヽ(°▽°)ノ✿),这个题目就让我想起了它。
#include
#include
#include
#include
using namespace std;int n,b,W,sum,num[25],f[2000000];int main(){ scanf("%d%d",&n,&b); for(int i=1;i<=n;i++){ scanf("%d",&num[i]); sum+=num[i]; } W=sum-b; for(int i=1;i<=n;i++) for(int j=W;j>=num[i];j--) f[j]=max(f[j],f[j-num[i]]+num[i]); printf("%d",sum-f[W]-b);}

 

转载于:https://www.cnblogs.com/cangT-Tlan/p/7434530.html

你可能感兴趣的文章
网络知识整理
查看>>
windows下搭建iphone开发环境
查看>>
远程桌面剪贴板失效的解决办法
查看>>
Mybatis框架插件PageHelper的使用
查看>>
Apache ab 压力测试工具
查看>>
C# 取二位小数点(四舍五入)
查看>>
黑马程序员——程序结构
查看>>
crawlspider
查看>>
正则表达式及其应用
查看>>
整理90部好看的经典喜剧片
查看>>
美丽的数学家:如果您讨厌数学,这些其实都是人生故事
查看>>
MVC判断用是否登录了平台
查看>>
统计剩余字数(jq版)
查看>>
HDU 4747 Mex【线段树上二分+扫描线】
查看>>
noi.ac NOIP2018 全国热身赛 第四场 T1 tree
查看>>
Apicloud——关于索引列表
查看>>
(转)linux下vi编辑器编写C语言的配置
查看>>
多线程基础知识 转
查看>>
MyBatis generator 使用方式 小结
查看>>
Android小项目之五 splash动画效果
查看>>